package com.hello2morrow.foundation.utilities

import groovy.text.SimpleTemplateEngine
import de.schlichtherle.truezip.file.TFile

public class TemplateUtility
{
    public static String expandTemplate(String fileName, Map<String, Object> binding) throws GroovyRuntimeException
    {
        assert fileName != null && fileName.length() > 0 : "Parameter 'fileName' of method 'expandTemplate' must not be empty";
        assert binding != null : "Parameter 'binding' of method 'enclosing_method' must not be null";

        TFile file = new TFile(fileName)

        def templateText = file.getText()
        return expandTemplateText(templateText, binding);
    }


    public static String expandTemplateText(String templateText, Map<String, ? extends Object> binding) throws GroovyRuntimeException
    {
        if (templateText == null)
        {
            return null
        }

        def engine = new SimpleTemplateEngine()
        def result = null;
        def template = engine.createTemplate(templateText)
        def copyOfBinding = new HashMap()
        
        copyOfBinding << binding;
        result = template.make(copyOfBinding).toString()
        return result.replaceAll("\\r", "")
    }

    public static List<String> expandTemplateToLines(String fileName, Map<String, Object> binding) throws GroovyRuntimeException
    {
        def expandedTemplate = expandTemplate(fileName, binding)

        if (expandedTemplate == null)
        {
            return null;
        }

        List<String> result = new ArrayList<String>()

        expandedTemplate.eachLine
        { result.add(it) }
        return result
    }
}